/* menu-widget.c generated by valac 0.56.14, the Vala compiler
 * generated from menu-widget.vala, do not modify */

/*
 * vala-panel-appmenu
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "libappmenu.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

enum  {
	APPMENU_MENU_WIDGET_0_PROPERTY,
	APPMENU_MENU_WIDGET_COMPACT_MODE_PROPERTY,
	APPMENU_MENU_WIDGET_BOLD_APPLICATION_NAME_PROPERTY,
	APPMENU_MENU_WIDGET_NUM_PROPERTIES
};
static GParamSpec* appmenu_menu_widget_properties[APPMENU_MENU_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define APPMENU_TYPE_BACKEND_IMPL (appmenu_backend_impl_get_type ())
#define APPMENU_BACKEND_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPMENU_TYPE_BACKEND_IMPL, AppmenuBackendImpl))
#define APPMENU_BACKEND_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPMENU_TYPE_BACKEND_IMPL, AppmenuBackendImplClass))
#define APPMENU_IS_BACKEND_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPMENU_TYPE_BACKEND_IMPL))
#define APPMENU_IS_BACKEND_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPMENU_TYPE_BACKEND_IMPL))
#define APPMENU_BACKEND_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPMENU_TYPE_BACKEND_IMPL, AppmenuBackendImplClass))

typedef struct _AppmenuBackendImpl AppmenuBackendImpl;
typedef struct _AppmenuBackendImplClass AppmenuBackendImplClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AppmenuMenuWidgetPrivate {
	gboolean _compact_mode;
	gboolean _bold_application_name;
	GtkAdjustment* scroll_adj;
	GtkScrolledWindow* scroller;
	GtkCssProvider* provider;
	GMenuModel* appmenu;
	GMenuModel* menubar;
	AppmenuBackend* backend;
	GtkMenuBar* mwidget;
	gulong backend_connector;
	gulong compact_connector;
};

static gint AppmenuMenuWidget_private_offset;
static gpointer appmenu_menu_widget_parent_class = NULL;

VALA_EXTERN AppmenuBackendImpl* appmenu_backend_impl_new (void);
VALA_EXTERN AppmenuBackendImpl* appmenu_backend_impl_construct (GType object_type);
VALA_EXTERN GType appmenu_backend_impl_get_type (void) G_GNUC_CONST ;
static void appmenu_menu_widget_restock (AppmenuMenuWidget* self);
static void ___lambda8_ (AppmenuMenuWidget* self,
                  gint a,
                  gint b,
                  gint c);
static void ____lambda8__g_menu_model_items_changed (GMenuModel* _sender,
                                              gint position,
                                              gint removed,
                                              gint added,
                                              gpointer self);
static void appmenu_menu_widget_real_map (GtkWidget* base);
static GObject * appmenu_menu_widget_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _appmenu_menu_widget___lambda10_ (AppmenuMenuWidget* self);
static gboolean __lambda11_ (AppmenuMenuWidget* self);
static gboolean ___lambda11__gsource_func (gpointer self);
static void __appmenu_menu_widget___lambda10__appmenu_backend_active_model_changed (AppmenuBackend* _sender,
                                                                             gpointer self);
static gboolean _appmenu_menu_widget_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                       GdkEventScroll* event,
                                                                       gpointer self);
static void appmenu_menu_widget_finalize (GObject * obj);
static GType appmenu_menu_widget_get_type_once (void);
static void _vala_appmenu_menu_widget_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_appmenu_menu_widget_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
appmenu_menu_widget_get_instance_private (AppmenuMenuWidget* self)
{
	return G_STRUCT_MEMBER_P (self, AppmenuMenuWidget_private_offset);
}

AppmenuMenuWidget*
appmenu_menu_widget_construct (GType object_type)
{
	AppmenuMenuWidget * self = NULL;
#line 77 "../lib/menu-widget.vala"
	self = (AppmenuMenuWidget*) g_object_new (object_type, NULL);
#line 75 "../lib/menu-widget.vala"
	return self;
#line 128 "menu-widget.c"
}

AppmenuMenuWidget*
appmenu_menu_widget_new (void)
{
#line 75 "../lib/menu-widget.vala"
	return appmenu_menu_widget_construct (APPMENU_TYPE_MENU_WIDGET);
#line 136 "menu-widget.c"
}

static void
___lambda8_ (AppmenuMenuWidget* self,
             gint a,
             gint b,
             gint c)
{
#line 99 "../lib/menu-widget.vala"
	appmenu_menu_widget_restock (self);
#line 147 "menu-widget.c"
}

static void
____lambda8__g_menu_model_items_changed (GMenuModel* _sender,
                                         gint position,
                                         gint removed,
                                         gint added,
                                         gpointer self)
{
#line 98 "../lib/menu-widget.vala"
	___lambda8_ ((AppmenuMenuWidget*) self, position, removed, added);
#line 159 "menu-widget.c"
}

static void
appmenu_menu_widget_restock (AppmenuMenuWidget* self)
{
	GtkStyleContext* mcontext = NULL;
	GtkMenuBar* _tmp0_;
	GtkStyleContext* _tmp1_;
	gboolean _tmp2_;
	GMenu* menu = NULL;
	GMenu* _tmp5_;
	GMenuModel* _tmp6_;
	GMenuModel* _tmp9_;
	gint items = 0;
	GMenuModel* _tmp12_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_;
#line 79 "../lib/menu-widget.vala"
	g_return_if_fail (self != NULL);
#line 81 "../lib/menu-widget.vala"
	_tmp0_ = self->priv->mwidget;
#line 81 "../lib/menu-widget.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
#line 81 "../lib/menu-widget.vala"
	mcontext = _tmp1_;
#line 82 "../lib/menu-widget.vala"
	_tmp2_ = self->priv->_bold_application_name;
#line 82 "../lib/menu-widget.vala"
	if (_tmp2_) {
#line 191 "menu-widget.c"
		GtkStyleContext* _tmp3_;
#line 83 "../lib/menu-widget.vala"
		_tmp3_ = mcontext;
#line 83 "../lib/menu-widget.vala"
		gtk_style_context_add_class (_tmp3_, "-vala-panel-appmenu-bold");
#line 197 "menu-widget.c"
	} else {
		GtkStyleContext* _tmp4_;
#line 85 "../lib/menu-widget.vala"
		_tmp4_ = mcontext;
#line 85 "../lib/menu-widget.vala"
		gtk_style_context_remove_class (_tmp4_, "-vala-panel-appmenu-bold");
#line 204 "menu-widget.c"
	}
#line 86 "../lib/menu-widget.vala"
	_tmp5_ = g_menu_new ();
#line 86 "../lib/menu-widget.vala"
	menu = _tmp5_;
#line 87 "../lib/menu-widget.vala"
	_tmp6_ = self->priv->appmenu;
#line 87 "../lib/menu-widget.vala"
	if (_tmp6_ != NULL) {
#line 214 "menu-widget.c"
		GMenu* _tmp7_;
		GMenuModel* _tmp8_;
#line 88 "../lib/menu-widget.vala"
		_tmp7_ = menu;
#line 88 "../lib/menu-widget.vala"
		_tmp8_ = self->priv->appmenu;
#line 88 "../lib/menu-widget.vala"
		g_menu_append_section (_tmp7_, NULL, _tmp8_);
#line 223 "menu-widget.c"
	}
#line 89 "../lib/menu-widget.vala"
	_tmp9_ = self->priv->menubar;
#line 89 "../lib/menu-widget.vala"
	if (_tmp9_ != NULL) {
#line 229 "menu-widget.c"
		GMenu* _tmp10_;
		GMenuModel* _tmp11_;
#line 90 "../lib/menu-widget.vala"
		_tmp10_ = menu;
#line 90 "../lib/menu-widget.vala"
		_tmp11_ = self->priv->menubar;
#line 90 "../lib/menu-widget.vala"
		g_menu_append_section (_tmp10_, NULL, _tmp11_);
#line 238 "menu-widget.c"
	}
#line 92 "../lib/menu-widget.vala"
	items = -1;
#line 93 "../lib/menu-widget.vala"
	_tmp12_ = self->priv->menubar;
#line 93 "../lib/menu-widget.vala"
	if (_tmp12_ != NULL) {
#line 246 "menu-widget.c"
		GMenuModel* _tmp13_;
#line 94 "../lib/menu-widget.vala"
		_tmp13_ = self->priv->menubar;
#line 94 "../lib/menu-widget.vala"
		items = g_menu_model_get_n_items (_tmp13_);
#line 252 "menu-widget.c"
	}
#line 96 "../lib/menu-widget.vala"
	_tmp15_ = self->priv->_compact_mode;
#line 96 "../lib/menu-widget.vala"
	if (_tmp15_) {
#line 96 "../lib/menu-widget.vala"
		_tmp14_ = items == 0;
#line 260 "menu-widget.c"
	} else {
#line 96 "../lib/menu-widget.vala"
		_tmp14_ = FALSE;
#line 264 "menu-widget.c"
	}
#line 96 "../lib/menu-widget.vala"
	if (_tmp14_) {
#line 268 "menu-widget.c"
		GMenuModel* _tmp16_;
		gulong _tmp17_;
#line 98 "../lib/menu-widget.vala"
		_tmp16_ = self->priv->menubar;
#line 98 "../lib/menu-widget.vala"
		_tmp17_ = g_signal_connect_object (_tmp16_, "items-changed", (GCallback) ____lambda8__g_menu_model_items_changed, self, 0);
#line 98 "../lib/menu-widget.vala"
		self->priv->compact_connector = _tmp17_;
#line 277 "menu-widget.c"
	}
#line 102 "../lib/menu-widget.vala"
	_tmp19_ = self->priv->_compact_mode;
#line 102 "../lib/menu-widget.vala"
	if (_tmp19_) {
#line 102 "../lib/menu-widget.vala"
		_tmp18_ = items > 0;
#line 285 "menu-widget.c"
	} else {
#line 102 "../lib/menu-widget.vala"
		_tmp18_ = FALSE;
#line 289 "menu-widget.c"
	}
#line 102 "../lib/menu-widget.vala"
	if (_tmp18_) {
#line 293 "menu-widget.c"
		GMenu* compact = NULL;
		GMenu* _tmp21_;
		gchar* name = NULL;
		GMenuModel* _tmp22_;
		GMenu* _tmp25_;
		const gchar* _tmp26_;
		GMenu* _tmp27_;
		GtkMenuBar* _tmp28_;
		GMenu* _tmp29_;
#line 104 "../lib/menu-widget.vala"
		if (self->priv->compact_connector > ((gulong) 0)) {
#line 305 "menu-widget.c"
			GMenuModel* _tmp20_;
#line 106 "../lib/menu-widget.vala"
			_tmp20_ = self->priv->menubar;
#line 106 "../lib/menu-widget.vala"
			g_signal_handler_disconnect ((GObject*) _tmp20_, self->priv->compact_connector);
#line 107 "../lib/menu-widget.vala"
			self->priv->compact_connector = (gulong) 0;
#line 313 "menu-widget.c"
		}
#line 109 "../lib/menu-widget.vala"
		_tmp21_ = g_menu_new ();
#line 109 "../lib/menu-widget.vala"
		compact = _tmp21_;
#line 110 "../lib/menu-widget.vala"
		name = NULL;
#line 111 "../lib/menu-widget.vala"
		_tmp22_ = self->priv->appmenu;
#line 111 "../lib/menu-widget.vala"
		if (_tmp22_ != NULL) {
#line 325 "menu-widget.c"
			GMenuModel* _tmp23_;
#line 112 "../lib/menu-widget.vala"
			_tmp23_ = self->priv->appmenu;
#line 112 "../lib/menu-widget.vala"
			g_menu_model_get_item_attribute (_tmp23_, 0, "label", "s", &name, NULL);
#line 331 "menu-widget.c"
		} else {
			gchar* _tmp24_;
#line 114 "../lib/menu-widget.vala"
			_tmp24_ = g_strdup (g_dgettext (CONFIG_GETTEXT_PACKAGE, "Compact Menu"));
#line 114 "../lib/menu-widget.vala"
			_g_free0 (name);
#line 114 "../lib/menu-widget.vala"
			name = _tmp24_;
#line 340 "menu-widget.c"
		}
#line 115 "../lib/menu-widget.vala"
		_tmp25_ = compact;
#line 115 "../lib/menu-widget.vala"
		_tmp26_ = name;
#line 115 "../lib/menu-widget.vala"
		_tmp27_ = menu;
#line 115 "../lib/menu-widget.vala"
		g_menu_append_submenu (_tmp25_, _tmp26_, (GMenuModel*) _tmp27_);
#line 116 "../lib/menu-widget.vala"
		_tmp28_ = self->priv->mwidget;
#line 116 "../lib/menu-widget.vala"
		_tmp29_ = compact;
#line 116 "../lib/menu-widget.vala"
		gtk_menu_shell_bind_model ((GtkMenuShell*) _tmp28_, (GMenuModel*) _tmp29_, NULL, TRUE);
#line 102 "../lib/menu-widget.vala"
		_g_free0 (name);
#line 102 "../lib/menu-widget.vala"
		_g_object_unref0 (compact);
#line 360 "menu-widget.c"
	} else {
		GtkMenuBar* _tmp30_;
		GMenu* _tmp31_;
#line 119 "../lib/menu-widget.vala"
		_tmp30_ = self->priv->mwidget;
#line 119 "../lib/menu-widget.vala"
		_tmp31_ = menu;
#line 119 "../lib/menu-widget.vala"
		gtk_menu_shell_bind_model ((GtkMenuShell*) _tmp30_, (GMenuModel*) _tmp31_, NULL, TRUE);
#line 370 "menu-widget.c"
	}
#line 79 "../lib/menu-widget.vala"
	_g_object_unref0 (menu);
#line 374 "menu-widget.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 123 "../lib/menu-widget.vala"
	return self ? g_object_ref (self) : NULL;
#line 382 "menu-widget.c"
}

void
appmenu_menu_widget_set_appmenu (AppmenuMenuWidget* self,
                                 GMenuModel* appmenu_model)
{
	GMenuModel* _tmp0_;
#line 121 "../lib/menu-widget.vala"
	g_return_if_fail (self != NULL);
#line 123 "../lib/menu-widget.vala"
	_tmp0_ = _g_object_ref0 (appmenu_model);
#line 123 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->appmenu);
#line 123 "../lib/menu-widget.vala"
	self->priv->appmenu = _tmp0_;
#line 124 "../lib/menu-widget.vala"
	appmenu_menu_widget_restock (self);
#line 400 "menu-widget.c"
}

void
appmenu_menu_widget_set_menubar (AppmenuMenuWidget* self,
                                 GMenuModel* menubar_model)
{
	GMenuModel* _tmp0_;
#line 126 "../lib/menu-widget.vala"
	g_return_if_fail (self != NULL);
#line 128 "../lib/menu-widget.vala"
	_tmp0_ = _g_object_ref0 (menubar_model);
#line 128 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->menubar);
#line 128 "../lib/menu-widget.vala"
	self->priv->menubar = _tmp0_;
#line 129 "../lib/menu-widget.vala"
	appmenu_menu_widget_restock (self);
#line 418 "menu-widget.c"
}

gboolean
appmenu_menu_widget_on_scroll_event (AppmenuMenuWidget* self,
                                     GtkWidget* w,
                                     GdkEventScroll* event)
{
	gdouble val = 0.0;
	GtkAdjustment* _tmp0_;
	gdouble incr = 0.0;
	GtkAdjustment* _tmp1_;
	gboolean result;
#line 131 "../lib/menu-widget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 131 "../lib/menu-widget.vala"
	g_return_val_if_fail (w != NULL, FALSE);
#line 131 "../lib/menu-widget.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 133 "../lib/menu-widget.vala"
	_tmp0_ = self->priv->scroll_adj;
#line 133 "../lib/menu-widget.vala"
	val = gtk_adjustment_get_value (_tmp0_);
#line 134 "../lib/menu-widget.vala"
	_tmp1_ = self->priv->scroll_adj;
#line 134 "../lib/menu-widget.vala"
	incr = gtk_adjustment_get_step_increment (_tmp1_);
#line 135 "../lib/menu-widget.vala"
	if (event->direction == GDK_SCROLL_UP) {
#line 447 "menu-widget.c"
		GtkAdjustment* _tmp2_;
#line 137 "../lib/menu-widget.vala"
		_tmp2_ = self->priv->scroll_adj;
#line 137 "../lib/menu-widget.vala"
		gtk_adjustment_set_value (_tmp2_, val - incr);
#line 138 "../lib/menu-widget.vala"
		result = TRUE;
#line 138 "../lib/menu-widget.vala"
		return result;
#line 457 "menu-widget.c"
	}
#line 140 "../lib/menu-widget.vala"
	if (event->direction == GDK_SCROLL_DOWN) {
#line 461 "menu-widget.c"
		GtkAdjustment* _tmp3_;
#line 142 "../lib/menu-widget.vala"
		_tmp3_ = self->priv->scroll_adj;
#line 142 "../lib/menu-widget.vala"
		gtk_adjustment_set_value (_tmp3_, val + incr);
#line 143 "../lib/menu-widget.vala"
		result = TRUE;
#line 143 "../lib/menu-widget.vala"
		return result;
#line 471 "menu-widget.c"
	}
#line 145 "../lib/menu-widget.vala"
	if (event->direction == GDK_SCROLL_LEFT) {
#line 475 "menu-widget.c"
		GtkAdjustment* _tmp4_;
#line 147 "../lib/menu-widget.vala"
		_tmp4_ = self->priv->scroll_adj;
#line 147 "../lib/menu-widget.vala"
		gtk_adjustment_set_value (_tmp4_, val - incr);
#line 148 "../lib/menu-widget.vala"
		result = TRUE;
#line 148 "../lib/menu-widget.vala"
		return result;
#line 485 "menu-widget.c"
	}
#line 150 "../lib/menu-widget.vala"
	if (event->direction == GDK_SCROLL_RIGHT) {
#line 489 "menu-widget.c"
		GtkAdjustment* _tmp5_;
#line 152 "../lib/menu-widget.vala"
		_tmp5_ = self->priv->scroll_adj;
#line 152 "../lib/menu-widget.vala"
		gtk_adjustment_set_value (_tmp5_, val + incr);
#line 153 "../lib/menu-widget.vala"
		result = TRUE;
#line 153 "../lib/menu-widget.vala"
		return result;
#line 499 "menu-widget.c"
	}
#line 155 "../lib/menu-widget.vala"
	if (event->direction == GDK_SCROLL_SMOOTH) {
#line 503 "menu-widget.c"
		GtkAdjustment* _tmp6_;
#line 157 "../lib/menu-widget.vala"
		_tmp6_ = self->priv->scroll_adj;
#line 157 "../lib/menu-widget.vala"
		gtk_adjustment_set_value (_tmp6_, val + (incr * (event->delta_y + event->delta_x)));
#line 158 "../lib/menu-widget.vala"
		result = TRUE;
#line 158 "../lib/menu-widget.vala"
		return result;
#line 513 "menu-widget.c"
	}
#line 160 "../lib/menu-widget.vala"
	result = FALSE;
#line 160 "../lib/menu-widget.vala"
	return result;
#line 519 "menu-widget.c"
}

static void
appmenu_menu_widget_real_map (GtkWidget* base)
{
	AppmenuMenuWidget * self;
	GtkSettings* gtksettings = NULL;
	GtkSettings* _tmp0_;
#line 162 "../lib/menu-widget.vala"
	self = (AppmenuMenuWidget*) base;
#line 164 "../lib/menu-widget.vala"
	GTK_WIDGET_CLASS (appmenu_menu_widget_parent_class)->map ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin));
#line 165 "../lib/menu-widget.vala"
	_tmp0_ = gtk_widget_get_settings ((GtkWidget*) self);
#line 165 "../lib/menu-widget.vala"
	gtksettings = _tmp0_;
#line 166 "../lib/menu-widget.vala"
	g_object_set (gtksettings, "gtk-shell-shows-app-menu", FALSE, NULL);
#line 167 "../lib/menu-widget.vala"
	g_object_set (gtksettings, "gtk-shell-shows-menubar", FALSE, NULL);
#line 540 "menu-widget.c"
}

gboolean
appmenu_menu_widget_get_compact_mode (AppmenuMenuWidget* self)
{
	gboolean result;
#line 31 "../lib/menu-widget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../lib/menu-widget.vala"
	result = self->priv->_compact_mode;
#line 31 "../lib/menu-widget.vala"
	return result;
#line 553 "menu-widget.c"
}

void
appmenu_menu_widget_set_compact_mode (AppmenuMenuWidget* self,
                                      gboolean value)
{
	gboolean old_value;
#line 31 "../lib/menu-widget.vala"
	g_return_if_fail (self != NULL);
#line 31 "../lib/menu-widget.vala"
	old_value = appmenu_menu_widget_get_compact_mode (self);
#line 31 "../lib/menu-widget.vala"
	if (old_value != value) {
#line 31 "../lib/menu-widget.vala"
		self->priv->_compact_mode = value;
#line 31 "../lib/menu-widget.vala"
		g_object_notify_by_pspec ((GObject *) self, appmenu_menu_widget_properties[APPMENU_MENU_WIDGET_COMPACT_MODE_PROPERTY]);
#line 571 "menu-widget.c"
	}
}

gboolean
appmenu_menu_widget_get_bold_application_name (AppmenuMenuWidget* self)
{
	gboolean result;
#line 32 "../lib/menu-widget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../lib/menu-widget.vala"
	result = self->priv->_bold_application_name;
#line 32 "../lib/menu-widget.vala"
	return result;
#line 585 "menu-widget.c"
}

void
appmenu_menu_widget_set_bold_application_name (AppmenuMenuWidget* self,
                                               gboolean value)
{
	gboolean old_value;
#line 32 "../lib/menu-widget.vala"
	g_return_if_fail (self != NULL);
#line 32 "../lib/menu-widget.vala"
	old_value = appmenu_menu_widget_get_bold_application_name (self);
#line 32 "../lib/menu-widget.vala"
	if (old_value != value) {
#line 32 "../lib/menu-widget.vala"
		self->priv->_bold_application_name = value;
#line 32 "../lib/menu-widget.vala"
		g_object_notify_by_pspec ((GObject *) self, appmenu_menu_widget_properties[APPMENU_MENU_WIDGET_BOLD_APPLICATION_NAME_PROPERTY]);
#line 603 "menu-widget.c"
	}
}

static gboolean
__lambda11_ (AppmenuMenuWidget* self)
{
	AppmenuBackend* _tmp0_;
	gboolean result;
#line 52 "../lib/menu-widget.vala"
	_tmp0_ = self->priv->backend;
#line 52 "../lib/menu-widget.vala"
	appmenu_backend_set_active_window_menu (_tmp0_, self);
#line 53 "../lib/menu-widget.vala"
	result = G_SOURCE_REMOVE;
#line 53 "../lib/menu-widget.vala"
	return result;
#line 620 "menu-widget.c"
}

static gboolean
___lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda11_ ((AppmenuMenuWidget*) self);
#line 51 "../lib/menu-widget.vala"
	return result;
#line 630 "menu-widget.c"
}

static void
_appmenu_menu_widget___lambda10_ (AppmenuMenuWidget* self)
{
#line 51 "../lib/menu-widget.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ___lambda11__gsource_func, g_object_ref (self), g_object_unref);
#line 638 "menu-widget.c"
}

static void
__appmenu_menu_widget___lambda10__appmenu_backend_active_model_changed (AppmenuBackend* _sender,
                                                                        gpointer self)
{
#line 50 "../lib/menu-widget.vala"
	_appmenu_menu_widget___lambda10_ ((AppmenuMenuWidget*) self);
#line 647 "menu-widget.c"
}

static gboolean
_appmenu_menu_widget_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                              GdkEventScroll* event,
                                                              gpointer self)
{
	gboolean result;
	result = appmenu_menu_widget_on_scroll_event ((AppmenuMenuWidget*) self, _sender, event);
#line 64 "../lib/menu-widget.vala"
	return result;
#line 659 "menu-widget.c"
}

static GObject *
appmenu_menu_widget_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppmenuMenuWidget * self;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* mcontext = NULL;
	GtkMenuBar* _tmp4_;
	GtkStyleContext* _tmp5_;
	AppmenuBackend* _tmp6_;
	gulong _tmp7_;
	GtkStyleContext* _tmp8_;
	GdkScreen* _tmp9_;
	GtkCssProvider* _tmp10_;
	GtkAdjustment* _tmp11_;
	GtkAdjustment* _tmp12_;
	GtkScrolledWindow* _tmp13_;
	GtkScrolledWindow* _tmp14_;
	GtkScrolledWindow* _tmp15_;
	GtkScrolledWindow* _tmp16_;
	GtkScrolledWindow* _tmp17_;
	GtkScrolledWindow* _tmp18_;
	GtkScrolledWindow* _tmp19_;
	GtkScrolledWindow* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkScrolledWindow* _tmp22_;
	GtkScrolledWindow* _tmp23_;
	GtkMenuBar* _tmp24_;
	GtkMenuBar* _tmp25_;
	GtkScrolledWindow* _tmp26_;
#line 42 "../lib/menu-widget.vala"
	parent_class = G_OBJECT_CLASS (appmenu_menu_widget_parent_class);
#line 42 "../lib/menu-widget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 42 "../lib/menu-widget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPMENU_TYPE_MENU_WIDGET, AppmenuMenuWidget);
#line 44 "../lib/menu-widget.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 44 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->provider);
#line 44 "../lib/menu-widget.vala"
	self->priv->provider = _tmp0_;
#line 45 "../lib/menu-widget.vala"
	_tmp1_ = self->priv->provider;
#line 45 "../lib/menu-widget.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "/org/vala-panel/appmenu/appmenu.css");
#line 46 "../lib/menu-widget.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 46 "../lib/menu-widget.vala"
	context = _tmp2_;
#line 47 "../lib/menu-widget.vala"
	_tmp3_ = context;
#line 47 "../lib/menu-widget.vala"
	gtk_style_context_add_class (_tmp3_, "-vala-panel-appmenu-core");
#line 48 "../lib/menu-widget.vala"
	_tmp4_ = self->priv->mwidget;
#line 48 "../lib/menu-widget.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 48 "../lib/menu-widget.vala"
	mcontext = _tmp5_;
#line 49 "../lib/menu-widget.vala"
	g_signal_connect (self, "notify", (GCallback) appmenu_menu_widget_restock, NULL);
#line 50 "../lib/menu-widget.vala"
	_tmp6_ = self->priv->backend;
#line 50 "../lib/menu-widget.vala"
	_tmp7_ = g_signal_connect_object (_tmp6_, "active-model-changed", (GCallback) __appmenu_menu_widget___lambda10__appmenu_backend_active_model_changed, self, 0);
#line 50 "../lib/menu-widget.vala"
	self->priv->backend_connector = _tmp7_;
#line 56 "../lib/menu-widget.vala"
	_tmp8_ = mcontext;
#line 56 "../lib/menu-widget.vala"
	gtk_style_context_add_class (_tmp8_, "-vala-panel-appmenu-private");
#line 57 "../lib/menu-widget.vala"
	_tmp9_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 57 "../lib/menu-widget.vala"
	_tmp10_ = self->priv->provider;
#line 57 "../lib/menu-widget.vala"
	gtk_style_context_add_provider_for_screen (_tmp9_, (GtkStyleProvider*) _tmp10_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 59 "../lib/menu-widget.vala"
	_tmp11_ = gtk_adjustment_new ((gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 20, (gdouble) 20, (gdouble) 0);
#line 59 "../lib/menu-widget.vala"
	g_object_ref_sink (_tmp11_);
#line 59 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->scroll_adj);
#line 59 "../lib/menu-widget.vala"
	self->priv->scroll_adj = _tmp11_;
#line 60 "../lib/menu-widget.vala"
	_tmp12_ = self->priv->scroll_adj;
#line 60 "../lib/menu-widget.vala"
	_tmp13_ = (GtkScrolledWindow*) gtk_scrolled_window_new (_tmp12_, NULL);
#line 60 "../lib/menu-widget.vala"
	g_object_ref_sink (_tmp13_);
#line 60 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->scroller);
#line 60 "../lib/menu-widget.vala"
	self->priv->scroller = _tmp13_;
#line 61 "../lib/menu-widget.vala"
	_tmp14_ = self->priv->scroller;
#line 61 "../lib/menu-widget.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp14_, TRUE);
#line 62 "../lib/menu-widget.vala"
	_tmp15_ = self->priv->scroller;
#line 62 "../lib/menu-widget.vala"
	gtk_scrolled_window_set_policy (_tmp15_, GTK_POLICY_EXTERNAL, GTK_POLICY_NEVER);
#line 63 "../lib/menu-widget.vala"
	_tmp16_ = self->priv->scroller;
#line 63 "../lib/menu-widget.vala"
	gtk_scrolled_window_set_shadow_type (_tmp16_, GTK_SHADOW_NONE);
#line 64 "../lib/menu-widget.vala"
	_tmp17_ = self->priv->scroller;
#line 64 "../lib/menu-widget.vala"
	g_signal_connect_object ((GtkWidget*) _tmp17_, "scroll-event", (GCallback) _appmenu_menu_widget_on_scroll_event_gtk_widget_scroll_event, self, 0);
#line 65 "../lib/menu-widget.vala"
	_tmp18_ = self->priv->scroller;
#line 65 "../lib/menu-widget.vala"
	gtk_scrolled_window_set_min_content_width (_tmp18_, 16);
#line 66 "../lib/menu-widget.vala"
	_tmp19_ = self->priv->scroller;
#line 66 "../lib/menu-widget.vala"
	gtk_scrolled_window_set_min_content_height (_tmp19_, 16);
#line 67 "../lib/menu-widget.vala"
	_tmp20_ = self->priv->scroller;
#line 67 "../lib/menu-widget.vala"
	gtk_scrolled_window_set_propagate_natural_height (_tmp20_, TRUE);
#line 68 "../lib/menu-widget.vala"
	_tmp21_ = self->priv->scroller;
#line 68 "../lib/menu-widget.vala"
	gtk_scrolled_window_set_propagate_natural_width (_tmp21_, TRUE);
#line 69 "../lib/menu-widget.vala"
	_tmp22_ = self->priv->scroller;
#line 69 "../lib/menu-widget.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp22_);
#line 70 "../lib/menu-widget.vala"
	_tmp23_ = self->priv->scroller;
#line 70 "../lib/menu-widget.vala"
	_tmp24_ = self->priv->mwidget;
#line 70 "../lib/menu-widget.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 71 "../lib/menu-widget.vala"
	_tmp25_ = self->priv->mwidget;
#line 71 "../lib/menu-widget.vala"
	gtk_widget_show ((GtkWidget*) _tmp25_);
#line 72 "../lib/menu-widget.vala"
	_tmp26_ = self->priv->scroller;
#line 72 "../lib/menu-widget.vala"
	gtk_widget_show ((GtkWidget*) _tmp26_);
#line 73 "../lib/menu-widget.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 42 "../lib/menu-widget.vala"
	return obj;
#line 819 "menu-widget.c"
}

static void
appmenu_menu_widget_class_init (AppmenuMenuWidgetClass * klass,
                                gpointer klass_data)
{
#line 29 "../lib/menu-widget.vala"
	appmenu_menu_widget_parent_class = g_type_class_peek_parent (klass);
#line 29 "../lib/menu-widget.vala"
	g_type_class_adjust_private_offset (klass, &AppmenuMenuWidget_private_offset);
#line 29 "../lib/menu-widget.vala"
	((GtkWidgetClass *) klass)->map = (void (*) (GtkWidget*)) appmenu_menu_widget_real_map;
#line 29 "../lib/menu-widget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_appmenu_menu_widget_get_property;
#line 29 "../lib/menu-widget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_appmenu_menu_widget_set_property;
#line 29 "../lib/menu-widget.vala"
	G_OBJECT_CLASS (klass)->constructor = appmenu_menu_widget_constructor;
#line 29 "../lib/menu-widget.vala"
	G_OBJECT_CLASS (klass)->finalize = appmenu_menu_widget_finalize;
#line 29 "../lib/menu-widget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPMENU_MENU_WIDGET_COMPACT_MODE_PROPERTY, appmenu_menu_widget_properties[APPMENU_MENU_WIDGET_COMPACT_MODE_PROPERTY] = g_param_spec_boolean ("compact-mode", "compact-mode", "compact-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../lib/menu-widget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPMENU_MENU_WIDGET_BOLD_APPLICATION_NAME_PROPERTY, appmenu_menu_widget_properties[APPMENU_MENU_WIDGET_BOLD_APPLICATION_NAME_PROPERTY] = g_param_spec_boolean ("bold-application-name", "bold-application-name", "bold-application-name", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 844 "menu-widget.c"
}

static void
appmenu_menu_widget_instance_init (AppmenuMenuWidget * self,
                                   gpointer klass)
{
	AppmenuBackendImpl* _tmp0_;
	GtkMenuBar* _tmp1_;
#line 29 "../lib/menu-widget.vala"
	self->priv = appmenu_menu_widget_get_instance_private (self);
#line 31 "../lib/menu-widget.vala"
	self->priv->_compact_mode = FALSE;
#line 32 "../lib/menu-widget.vala"
	self->priv->_bold_application_name = FALSE;
#line 33 "../lib/menu-widget.vala"
	self->priv->scroll_adj = NULL;
#line 34 "../lib/menu-widget.vala"
	self->priv->scroller = NULL;
#line 36 "../lib/menu-widget.vala"
	self->priv->appmenu = NULL;
#line 37 "../lib/menu-widget.vala"
	self->priv->menubar = NULL;
#line 38 "../lib/menu-widget.vala"
	_tmp0_ = appmenu_backend_impl_new ();
#line 38 "../lib/menu-widget.vala"
	self->priv->backend = (AppmenuBackend*) _tmp0_;
#line 39 "../lib/menu-widget.vala"
	_tmp1_ = (GtkMenuBar*) gtk_menu_bar_new ();
#line 39 "../lib/menu-widget.vala"
	g_object_ref_sink (_tmp1_);
#line 39 "../lib/menu-widget.vala"
	self->priv->mwidget = _tmp1_;
#line 40 "../lib/menu-widget.vala"
	self->priv->backend_connector = (gulong) 0;
#line 41 "../lib/menu-widget.vala"
	self->priv->compact_connector = (gulong) 0;
#line 881 "menu-widget.c"
}

static void
appmenu_menu_widget_finalize (GObject * obj)
{
	AppmenuMenuWidget * self;
#line 29 "../lib/menu-widget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPMENU_TYPE_MENU_WIDGET, AppmenuMenuWidget);
#line 33 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->scroll_adj);
#line 34 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->scroller);
#line 35 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->provider);
#line 36 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->appmenu);
#line 37 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->menubar);
#line 38 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->backend);
#line 39 "../lib/menu-widget.vala"
	_g_object_unref0 (self->priv->mwidget);
#line 29 "../lib/menu-widget.vala"
	G_OBJECT_CLASS (appmenu_menu_widget_parent_class)->finalize (obj);
#line 906 "menu-widget.c"
}

static GType
appmenu_menu_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AppmenuMenuWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) appmenu_menu_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppmenuMenuWidget), 0, (GInstanceInitFunc) appmenu_menu_widget_instance_init, NULL };
	GType appmenu_menu_widget_type_id;
	appmenu_menu_widget_type_id = g_type_register_static (gtk_bin_get_type (), "AppmenuMenuWidget", &g_define_type_info, 0);
	AppmenuMenuWidget_private_offset = g_type_add_instance_private (appmenu_menu_widget_type_id, sizeof (AppmenuMenuWidgetPrivate));
	return appmenu_menu_widget_type_id;
}

GType
appmenu_menu_widget_get_type (void)
{
	static volatile gsize appmenu_menu_widget_type_id__once = 0;
	if (g_once_init_enter (&appmenu_menu_widget_type_id__once)) {
		GType appmenu_menu_widget_type_id;
		appmenu_menu_widget_type_id = appmenu_menu_widget_get_type_once ();
		g_once_init_leave (&appmenu_menu_widget_type_id__once, appmenu_menu_widget_type_id);
	}
	return appmenu_menu_widget_type_id__once;
}

static void
_vala_appmenu_menu_widget_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	AppmenuMenuWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPMENU_TYPE_MENU_WIDGET, AppmenuMenuWidget);
#line 29 "../lib/menu-widget.vala"
	switch (property_id) {
#line 29 "../lib/menu-widget.vala"
		case APPMENU_MENU_WIDGET_COMPACT_MODE_PROPERTY:
#line 29 "../lib/menu-widget.vala"
		g_value_set_boolean (value, appmenu_menu_widget_get_compact_mode (self));
#line 29 "../lib/menu-widget.vala"
		break;
#line 29 "../lib/menu-widget.vala"
		case APPMENU_MENU_WIDGET_BOLD_APPLICATION_NAME_PROPERTY:
#line 29 "../lib/menu-widget.vala"
		g_value_set_boolean (value, appmenu_menu_widget_get_bold_application_name (self));
#line 29 "../lib/menu-widget.vala"
		break;
#line 953 "menu-widget.c"
		default:
#line 29 "../lib/menu-widget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../lib/menu-widget.vala"
		break;
#line 959 "menu-widget.c"
	}
}

static void
_vala_appmenu_menu_widget_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	AppmenuMenuWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPMENU_TYPE_MENU_WIDGET, AppmenuMenuWidget);
#line 29 "../lib/menu-widget.vala"
	switch (property_id) {
#line 29 "../lib/menu-widget.vala"
		case APPMENU_MENU_WIDGET_COMPACT_MODE_PROPERTY:
#line 29 "../lib/menu-widget.vala"
		appmenu_menu_widget_set_compact_mode (self, g_value_get_boolean (value));
#line 29 "../lib/menu-widget.vala"
		break;
#line 29 "../lib/menu-widget.vala"
		case APPMENU_MENU_WIDGET_BOLD_APPLICATION_NAME_PROPERTY:
#line 29 "../lib/menu-widget.vala"
		appmenu_menu_widget_set_bold_application_name (self, g_value_get_boolean (value));
#line 29 "../lib/menu-widget.vala"
		break;
#line 985 "menu-widget.c"
		default:
#line 29 "../lib/menu-widget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../lib/menu-widget.vala"
		break;
#line 991 "menu-widget.c"
	}
}

